#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <iomanip>
#include <stdio.h>
#include <sys/stat.h>

#include "asim/rrr/service_ids.h"

#include "asim/provides/connected_application.h"



using namespace std;

// ===== service instantiation =====
PROCESSORSYSTEMRRR_SERVER_CLASS PROCESSORSYSTEMRRR_SERVER_CLASS::instance;

// constructor
PROCESSORSYSTEMRRR_SERVER_CLASS::PROCESSORSYSTEMRRR_SERVER_CLASS() :
  serverStub(new PROCESSORSYSTEMRRR_SERVER_STUB_CLASS(this))
{
    // instantiate stub
    memory = NULL;
    fflush(stdout);
}

// destructor
PROCESSORSYSTEMRRR_SERVER_CLASS::~PROCESSORSYSTEMRRR_SERVER_CLASS()
{
    Cleanup();
}

// init
void
PROCESSORSYSTEMRRR_SERVER_CLASS::Init(PLATFORMS_MODULE p)
{
    parent = p;
}

// uninit
void
PROCESSORSYSTEMRRR_SERVER_CLASS::Uninit()
{
    Cleanup();
}

// cleanup
void
PROCESSORSYSTEMRRR_SERVER_CLASS::Cleanup()
{
    delete serverStub;
}


//
// RRR service methods
//

UINT32
PROCESSORSYSTEMRRR_SERVER_CLASS::MemoryRequestLoad (UINT32 address)
{
  UINT32 returnVal;
  
  if(memory == NULL) {
    memory = new FUNCP_SIMULATED_MEMORY_CLASS();
  }


 
  memory->Read(0,(UINT64) address, sizeof(UINT32), &returnVal); 
  return returnVal;
}

void
PROCESSORSYSTEMRRR_SERVER_CLASS::MemoryRequestStore (UINT32 address, UINT32 data)
{
  if(memory == NULL) {
    memory = new FUNCP_SIMULATED_MEMORY_CLASS();
  }

  memory->Write(0,(UINT64) address, sizeof(UINT32), &data); 
}
